package org.gcube.portlets.user.td.columnwidget.client.store;

import java.io.Serializable;
import java.util.ArrayList;

import org.gcube.portlets.user.td.widgetcommonevent.shared.tr.column.TimeDimensionType;




/**
 * 
 * @author "Giancarlo Panichi" <a
 *         href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a>
 * 
 */
public class TimeDimensionTypeStore implements Serializable {

	private static final long serialVersionUID = -5669638279415262224L;

	protected static ArrayList<TimeDimensionTypeElement> store;
	
	protected static TimeDimensionTypeElement dayElement=new TimeDimensionTypeElement(1,TimeDimensionType.Day);
	protected static TimeDimensionTypeElement monthElement=new TimeDimensionTypeElement(2,TimeDimensionType.Month);
	protected static TimeDimensionTypeElement quarterElement=new TimeDimensionTypeElement(3,TimeDimensionType.Quarter);
	protected static TimeDimensionTypeElement yearElement=new TimeDimensionTypeElement(4,TimeDimensionType.Year);
	

	public static ArrayList<TimeDimensionTypeElement> getTimeDimensionType(){
		store=new ArrayList<TimeDimensionTypeElement>();
		store.add(dayElement);
		store.add(monthElement);
		store.add(quarterElement);
		store.add(yearElement);
		return store;
	}
	
	public static int selectedTimeDimensionPosition(String selected){
		int position=0;
		if(selected.compareTo(TimeDimensionType.Day.toString())==0){
			position=1;
		} else {
			if(selected.compareTo(TimeDimensionType.Month.toString())==0){
				position=2;
			} else {
				if(selected.compareTo(TimeDimensionType.Quarter.toString())==0){
					position=3;
				} else {
					if(selected.compareTo(TimeDimensionType.Year.toString())==0){
						position=4;
					} else {
					}
				}
			}
		}
		return position;
	}
	
	
	public static TimeDimensionType selectedTimeDimension(String selected){
		if(selected.compareTo(TimeDimensionType.Day.toString())==0){
			return TimeDimensionType.Day;
		} else {
			if(selected.compareTo(TimeDimensionType.Month.toString())==0){
				return TimeDimensionType.Month;
			} else {
				if(selected.compareTo(TimeDimensionType.Quarter.toString())==0){
					return TimeDimensionType.Quarter;
				} else {
					if(selected.compareTo(TimeDimensionType.Year.toString())==0){
						return TimeDimensionType.Year;
					} else {
						return null;
					}
				}
			}
		}
	}
	
	public static TimeDimensionTypeElement selectedTimeDimensionElement(String selected){
		if(selected.compareTo(TimeDimensionType.Day.toString())==0){
			return dayElement;
		} else {
			if(selected.compareTo(TimeDimensionType.Month.toString())==0){
				return monthElement;
			} else {
				if(selected.compareTo(TimeDimensionType.Quarter.toString())==0){
					return quarterElement;
				} else {
					if(selected.compareTo(TimeDimensionType.Year.toString())==0){
						return yearElement;
					} else {
						return null;
					}
				}
			}
		}
	}
	
}
